package healthhelper.logic.impl;

import healthhelper.dao.MenuDao;
import healthhelper.dto.Dto;
import healthhelper.entity.Menu;
import healthhelper.logic.Rule;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;


public class RuleImpl2 implements Rule {

	private MenuDao menuDao;
	
	public List execute(Dto dto) {

		List menuList = menuDao.getAllMenu();
		List retList = new ArrayList();
		int amount = 0;
		
		switchRule(dto, menuList, retList, amount);
		
		return retList;
	}

	private void switchRule(Dto dto, List menuList, List retList, int amount) {
		if(dto.isCarefulCalorie()){
			setTwoMenu(retList, menuList);
		}else{
			setReturnMenuList(dto, retList, menuList, amount);
		}
	}

	private void setTwoMenu(List retList, List menuList) {
		Random random = new Random();
		int i = 0;
		i = random.nextInt(menuList.size());
		retList.add((Menu)menuList.get(i));
		i = random.nextInt(menuList.size());
		retList.add((Menu)menuList.get(i));
	}

	private void setReturnMenuList(Dto dto, List retList, List menuList, int amount) {
		for(int i=0; amount <= dto.getBudget() && i < menuList.size(); i++ ){
			amount = getReturnMenu(dto, retList, menuList, amount, i);
		}
	}

	private int getReturnMenu(Dto dto, List retList, List menuList, int amount, int i) {
		Menu menu = (Menu) menuList.get(i);
		amount = amount + menu.getPrice();
		if(amount <= dto.getBudget()){
			retList.add(menu);
		}
		return amount;
	}

	public MenuDao getMenuDao() {
		return menuDao;
	}

	public void setMenuDao(MenuDao menuDao) {
		this.menuDao = menuDao;
	}
}
